<template>
  <v-data-table
    v-model="selected"
    :headers="headers"
    :items="products"
    :search="search"
    item-key="name"
    show-select
    sort-by="cost"
    class="elevation-1"
  >

    <template v-slot:top>
      <v-toolbar flat color="white" margin="400px">
        <v-toolbar-title>Seleccion de Productos</v-toolbar-title>

        
        <!-- <p>{{ selected }}</p> -->
        <v-divider class="mx-4" inset vertical></v-divider>

        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Buscar"
          single-line
          hide-details
        ></v-text-field>

        <v-spacer></v-spacer>
        <v-dialog v-model="dialog" max-width="500px">
          <template v-slot:activator="{ on }">
            <v-btn color="#414142" dark class="mb-2" v-on="on">Nuevo Paquete</v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="headline">{{ formTitle }}</span>
            </v-card-title>
            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.name" label="Nombre del Paquete"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.cost" label="Precio del Paquete"></v-text-field>
                  </v-col>
                  <picture-input
                    v-model="photoModel"
                    ref="pictureInput"
                    style="width:50%; height:50%;"
                    margin="16"
                    accept="image/jpeg, image/png"
                    size="10"
                    buttonClass="btn"
                    :customStrings="{
                  upload: '<h1>Bummer!</h1>',
                  drag: 'Arrastra una imágen aquí'
                }"
                  ></picture-input>
                  <!-- <v-col cols="12" sm="6" md="4">
                    <v-btn v-model="productSelect">Agregar Productos</v-btn>
                  </v-col>-->

                  <!-- <v-select v-model="e7" :items="items" label="Solo field" dense solo ></v-select> -->
                </v-row>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="#414142" text @click="close">Cancelar</v-btn>
              <v-btn color="#414142" text @click="save">Guardar</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:no-data>
      <v-btn color="primary" @click="initialize">Reset</v-btn>
    </template>
  </v-data-table>
</template>


<script>
import PictureInput from "vue-picture-input";
import firebase from "firebase/app";
export default {
  components: {
    PictureInput
  },
  data: () => ({
    photoModel: "",
    dialog: false,
    search: "",
    selected: [],
    switch1: true,
    headers: [
      {
        text: "Nombre del Producto",
        align: "start",
        sortable: false,
        value: "name"
      },
      { text: "Precio Actual", value: "cost" },
      { text: "Categoria", value: "category" },
    ],
    products: [],
    datos: [],
    items2: [
      { title: "Frutas" },
      { title: "Verduras y Hortalizas" },
      { title: "Carnicos" },
      { title: "Abarrotes/Granos y Semillas" }
    ],
    editedIndex: -1,
    newItem: {
      name: "",
      cost: "",
      photo: "",
      products: []
    },
    editedItem: {
      id: "",
      name: "",
      precioActual: 0,
      nuevoPrecio: 0,
      categoria: 0,
      Estado: true
    },
    defaultItem: {
      name: "",
      precioActual: 0,
      nuevoPrecio: 0,
      categoria: 0,
      Estado: true
    }
  }),

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? "Nevo Paquete" : "Editar Paquete";
    }
  },

  watch: {
    dialog(val) {
      val || this.close();
    }
  },

  created() {
    this.initialize();
  },

  methods: {
    initialize() {
      this.$axios
        .get(`http://${process.env.VUE_APP_API_URL}/api/products`)
        .then(res => {
          res.data.data.forEach(product => {
            console.log(product);
            product.products.forEach(product2 => {
              this.products.push({
                id: product2.id,
                name: product2.info.product_name,
                cost: product2.info.cost,
                category: product2.info.product_category,
              });
            });
          });
          console.log(this.datos);
        });
    },

    editItem(item) {
      this.editedIndex = this.products.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      const index = this.products.indexOf(item);
      confirm("Desea eliminar este Producto?") &&
        this.products.splice(index, 1);
    },

    close() {
      this.dialog = false;
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      }, 300);
    },
    productSelect() {
      let productsSelect = JSON.stringify(this.selected);
      console.log(productsSelect);
      productsSelect = {
        id: productsSelect.id,
        data: {
          product_name: productsSelect.name,
          cost: productsSelect.precioActual,
          product_category: productsSelect.categoria
        }
      };
      console.log(productsSelect);
    },

    save() {
      const photoName = this.newItem.name
        .toLowerCase()
        .replace(/ /g, "");
      this.newItem.photo = "packages/" + photoName + ".jpg";
      var storageRef = firebase.storage().ref();
      var ref = storageRef.child(this.newItem.photo);
      ref.put(this.$refs.pictureInput.file);

      this.selected.forEach(element => {
        this.newItem.products.push(element);
      });

      this.newItem.cost = parseInt(this.newItem.cost)

      let _package = {
        body: {
          name: this.newItem.name,
          cost: this.newItem.cost,
          products: this.newItem.products,
          photo: this.newItem.photo,
        }
      };

      this.$axios
        .post(`http://${process.env.VUE_APP_API_URL}/api/packages`, _package)
        .then(res => {
          console.log(res);
        });
      this.close();
    }
  }
};
</script>
<style scoped>
  .elevation-1 {
    margin: 2%;
    border-radius: 10px;
  }
</style>

